В lenny 3й версии нет, поэтому будем устанавливать из squeeze:

# vi /etc/apt/sources.list

Меняем lenny на squeeze

Обновляем информацию о пакетах:

# apt-get update

И устанавливаем 3ю версию питона:

# apt-get install python3.1

Не забываем вернуть обратно lenny, если требуется